package com.xfront.owl;

public class OwlFileAccessor implements OwlAccessor
{
	public String getProperties(String classURI) 
	{
	   String propertyURIs = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getProperties"); 
		   TransformHelper.setParameter("classURI", classURI); 
		   propertyURIs = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return propertyURIs;      
	}

	public String getEquivalentProperties(String propertyURI) 
	{
	   String propertyURIs = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getEquivalentProperties"); 
		   TransformHelper.setParameter("propertyURI", propertyURI); 
		   propertyURIs = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return propertyURIs;      
	}

	public String getSuperClasses(String classURI) 
	{
	   String classURIs = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getSuperClasses"); 
		   TransformHelper.setParameter("classURI", classURI); 
		   classURIs = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return classURIs;      
	}

	public String getPropertyTypes(String propertyURI) 
	{
	   String propertyURIs = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getPropertyTypes"); 
		   TransformHelper.setParameter("propertyURI", propertyURI); 
		   propertyURIs = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return propertyURIs;      
	}

	public String getClassSpecificPropertyDefinitions(String classURI, String propertyURI) 
	{
	   String propertyDefinitions = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getClassSpecificPropertyDefinitions"); 
		   TransformHelper.setParameter("propertyURI", propertyURI); 
		   TransformHelper.setParameter("classURI", classURI); 
		   propertyDefinitions = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return propertyDefinitions;      
	}

	public String getDomain(String propertyURI) 
	{
	   String classURI = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getDomain"); 
		   TransformHelper.setParameter("propertyURI", propertyURI); 
		   classURI = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return classURI;              
	}

	public String getRange(String propertyURI) 
	{
	   String classURI = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getRange"); 
		   TransformHelper.setParameter("propertyURI", propertyURI); 
		   classURI = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return classURI;              
	}

	public String getInstances(String classURI) 
	{
	   String instances = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getInstances"); 
		   TransformHelper.setParameter("classURI", classURI); 
		   instances = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return instances;              
	}

	public String getEquivalentClasses(String classURI) 
	{
	   String classURIs = null;
	   try {
		   TransformHelper TransformHelper = new TransformHelper();  
		   TransformHelper.setParameter("methodName", "getEquivalentClasses"); 
		   TransformHelper.setParameter("classURI", classURI); 
		   classURIs = TransformHelper.doTransform();
		   TransformHelper.removeAllParameters();
	   } catch (Exception e) {e.printStackTrace();}
	   return classURIs;      
	}


	public static void main(String[] args) 
	{
	   OwlAccessor api = new OwlFileAccessor();
	   System.out.println("**** OWL API Test ****");
	   System.out.println("--------------------------------------------------------------------");
	   String propertyURIs = api.getProperties("http://www.xfront.com/owl/ontologies/camera/#Camera");

	   System.out.println("1. Get Properties of: http://www.xfront.com/owl/ontologies/camera/#Camera\n");
	   System.out.println(propertyURIs);
	   System.out.println("--------------------------------------------------------------------");

	   propertyURIs = api.getEquivalentProperties("http://www.xfront.com/owl/ontologies/camera/#size");

	   System.out.println("2. Get Equivalent Properties of: http://www.xfront.com/owl/ontologies/camera/#size\n");
	   System.out.println(propertyURIs);
	   System.out.println("--------------------------------------------------------------------");

	   String classURIs = api.getSuperClasses("http://www.xfront.com/owl/ontologies/camera/#SLR");

	   System.out.println("3. Get Super Classes of: http://www.xfront.com/owl/ontologies/camera/#SLR\n");
	   System.out.println(classURIs);
	   System.out.println("--------------------------------------------------------------------");

	   String propertyTypes = api.getPropertyTypes("http://www.xfront.com/owl/ontologies/gunLicense/#serial");

	   System.out.println("4. Get Property Types of: http://www.xfront.com/owl/ontologies/gunLicense/#serial\n");
	   System.out.println(propertyTypes);
	   System.out.println("--------------------------------------------------------------------");

	   String propertyDefinitions = api.getClassSpecificPropertyDefinitions("http://www.xfront.com/owl/ontologies/water/#River", "http://www.xfront.com/owl/ontologies/water/#connectsTo");

	   System.out.println("5. Get Class-Specific Property Definitions");
	   System.out.println("... of this property: http://www.xfront.com/owl/ontologies/water/#connectsTo");
	   System.out.println("... in this class: http://www.xfront.com/owl/ontologies/water/#River\n");
	   System.out.println(propertyDefinitions);
	   System.out.println("--------------------------------------------------------------------");

	   String classURI = api.getDomain("http://www.xfront.com/owl/ontologies/water/#emptiesInto");

	   System.out.println("6. Get Domain of Property: http://www.xfront.com/owl/ontologies/water/#emptiesInto\n");
	   System.out.println(classURI);
	   System.out.println("--------------------------------------------------------------------");

	   classURI = api.getRange("http://www.xfront.com/owl/ontologies/water/#emptiesInto");

	   System.out.println("7. Get Range of Property: http://www.xfront.com/owl/ontologies/water/#emptiesInto\n");
	   System.out.println(classURI);
	   System.out.println("--------------------------------------------------------------------");

	   String instances = api.getInstances("http://www.xfront.com/owl/ontologies/water/#Kyoto-Protected-River");

	   System.out.println("8. Get Instances of Class: http://www.xfront.com/owl/ontologies/water/#Kyoto-Protected-River\n");
	   System.out.println(instances);
	   System.out.println("--------------------------------------------------------------------");

	   classURIs = api.getEquivalentClasses("http://www.xfront.com/owl/ontologies/water/#BodyOfWater");

	   System.out.println("9. Get Equivalent Classes of: http://www.xfront.com/owl/ontologies/water/#BodyOfWater\n");
	   System.out.println(classURIs);
	   System.out.println("--------------------------------------------------------------------\n");
	}
}
